//=============================================================================
//
// file :         PiMercuryClass.h
//
// description :  Include for the PiMercuryClass root class.
//                This class is represents the singleton class for
//                the PiMercury device class.
//                It contains all properties and methods which the 
//                PiMercury requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: graziano $
//
// $Revision: 1.6 $
//
// $Log: PiMercuryClass.h,v $
// Revision 1.6  2016-08-23 12:06:21  graziano
// changed ChannelXOut to Out0X and added In01 ... In04
//
// Revision 1.5  2015-08-24 09:38:45  graziano
// added Out01 - Out04 attributes
//
// Revision 1.4  2013-07-09 08:08:33  graziano
// added command LoadConfig
//
// Revision 1.2  2009/04/14 12:40:26  graziano
// added rt_mode, scan mode, ...
//
// Revision 1.1  2008/11/19 10:28:46  graziano
// first version
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _PIMERCURYCLASS_H
#define _PIMERCURYCLASS_H

#include <tango.h>
#include <PiMercury.h>


namespace PiMercury_ns
{//=====================================
//	Define classes for attributes
//=====================================
class In04Attrib: public Tango::Attr
{
public:
	In04Attrib():Attr("In04", Tango::DEV_BOOLEAN, Tango::READ) {};
	~In04Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_In04(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_In04_allowed(ty);}
};

class In03Attrib: public Tango::Attr
{
public:
	In03Attrib():Attr("In03", Tango::DEV_BOOLEAN, Tango::READ) {};
	~In03Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_In03(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_In03_allowed(ty);}
};

class In02Attrib: public Tango::Attr
{
public:
	In02Attrib():Attr("In02", Tango::DEV_BOOLEAN, Tango::READ) {};
	~In02Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_In02(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_In02_allowed(ty);}
};

class In01Attrib: public Tango::Attr
{
public:
	In01Attrib():Attr("In01", Tango::DEV_BOOLEAN, Tango::READ) {};
	~In01Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_In01(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_In01_allowed(ty);}
};

class Out04Attrib: public Tango::Attr
{
public:
	Out04Attrib():Attr("Out04", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Out04Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_Out04(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PiMercury *>(dev))->write_Out04(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_Out04_allowed(ty);}
};

class Out03Attrib: public Tango::Attr
{
public:
	Out03Attrib():Attr("Out03", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Out03Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_Out03(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PiMercury *>(dev))->write_Out03(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_Out03_allowed(ty);}
};

class Out02Attrib: public Tango::Attr
{
public:
	Out02Attrib():Attr("Out02", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Out02Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_Out02(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PiMercury *>(dev))->write_Out02(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_Out02_allowed(ty);}
};

class Out01Attrib: public Tango::Attr
{
public:
	Out01Attrib():Attr("Out01", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Out01Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_Out01(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PiMercury *>(dev))->write_Out01(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_Out01_allowed(ty);}
};

class AxisConfigAttrib: public Tango::SpectrumAttr
{
public:
	AxisConfigAttrib():SpectrumAttr("AxisConfig", Tango::DEV_STRING, Tango::READ, 1024) {};
	~AxisConfigAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_AxisConfig(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_AxisConfig_allowed(ty);}
};

class LimitsAttrib: public Tango::SpectrumAttr
{
public:
	LimitsAttrib():SpectrumAttr("Limits", Tango::DEV_DOUBLE, Tango::READ_WRITE, 2) {};
	~LimitsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_Limits(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PiMercury *>(dev))->write_Limits(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_Limits_allowed(ty);}
};

class StatAttrib: public Tango::SpectrumAttr
{
public:
	StatAttrib():SpectrumAttr("Stat", Tango::DEV_BOOLEAN, Tango::READ, 40) {};
	~StatAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_Stat(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_Stat_allowed(ty);}
};

class ScanSpeedAttrib: public Tango::Attr
{
public:
	ScanSpeedAttrib():Attr("ScanSpeed", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ScanSpeedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_ScanSpeed(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PiMercury *>(dev))->write_ScanSpeed(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_ScanSpeed_allowed(ty);}
};

class RtModeAttrib: public Tango::Attr
{
public:
	RtModeAttrib():Attr("RtMode", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~RtModeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_RtMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PiMercury *>(dev))->write_RtMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_RtMode_allowed(ty);}
};

class ErrorAttrib: public Tango::Attr
{
public:
	ErrorAttrib():Attr("Error", Tango::DEV_STRING, Tango::READ) {};
	~ErrorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_Error(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_Error_allowed(ty);}
};

class TargetPositionAttrib: public Tango::Attr
{
public:
	TargetPositionAttrib():Attr("TargetPosition", Tango::DEV_DOUBLE, Tango::READ) {};
	~TargetPositionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_TargetPosition(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_TargetPosition_allowed(ty);}
};

class SpeedAttrib: public Tango::Attr
{
public:
	SpeedAttrib():Attr("Speed", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~SpeedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_Speed(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PiMercury *>(dev))->write_Speed(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_Speed_allowed(ty);}
};

class AccelerationAttrib: public Tango::Attr
{
public:
	AccelerationAttrib():Attr("Acceleration", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AccelerationAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_Acceleration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PiMercury *>(dev))->write_Acceleration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_Acceleration_allowed(ty);}
};

class PositionAttrib: public Tango::Attr
{
public:
	PositionAttrib():Attr("Position", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PositionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PiMercury *>(dev))->read_Position(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PiMercury *>(dev))->write_Position(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PiMercury *>(dev))->is_Position_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class StartScanClass : public Tango::Command
{
public:
	StartScanClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartScanClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartScanClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_StartScan_allowed(any);}
};



class CheckTriggerClass : public Tango::Command
{
public:
	CheckTriggerClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	CheckTriggerClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~CheckTriggerClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_CheckTrigger_allowed(any);}
};



class GetPositionClass : public Tango::Command
{
public:
	GetPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetPositionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_GetPosition_allowed(any);}
};



class LimitSwitchLevelCmd : public Tango::Command
{
public:
	LimitSwitchLevelCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LimitSwitchLevelCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LimitSwitchLevelCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_LimitSwitchLevel_allowed(any);}
};



class FindEdgeClass : public Tango::Command
{
public:
	FindEdgeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	FindEdgeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~FindEdgeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_FindEdge_allowed(any);}
};



class LimitSwitchEnableCmd : public Tango::Command
{
public:
	LimitSwitchEnableCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LimitSwitchEnableCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LimitSwitchEnableCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_LimitSwitchEnable_allowed(any);}
};



class SetHomeClass : public Tango::Command
{
public:
	SetHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetHomeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_SetHome_allowed(any);}
};



class MotorOFFClass : public Tango::Command
{
public:
	MotorOFFClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorOFFClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorOFFClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_MotorOFF_allowed(any);}
};



class MotorONClass : public Tango::Command
{
public:
	MotorONClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorONClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorONClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_MotorON_allowed(any);}
};



class GetVersionClass : public Tango::Command
{
public:
	GetVersionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetVersionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetVersionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_GetVersion_allowed(any);}
};



class GoHomeClass : public Tango::Command
{
public:
	GoHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GoHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GoHomeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_GoHome_allowed(any);}
};



class BrakeClass : public Tango::Command
{
public:
	BrakeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	BrakeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~BrakeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_Brake_allowed(any);}
};



class AbortClass : public Tango::Command
{
public:
	AbortClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AbortClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AbortClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_Abort_allowed(any);}
};



class StopCmd : public Tango::Command
{
public:
	StopCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_Stop_allowed(any);}
};



class BackwardCmd : public Tango::Command
{
public:
	BackwardCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	BackwardCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~BackwardCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_Backward_allowed(any);}
};



class ForwardClass : public Tango::Command
{
public:
	ForwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ForwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ForwardClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_Forward_allowed(any);}
};


class LoadConfigClass : public Tango::Command
{
public:
	LoadConfigClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LoadConfigClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LoadConfigClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PiMercury *>(dev))->is_LoadConfig_allowed(any);}
};



//
// The PiMercuryClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	PiMercuryClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static PiMercuryClass *init(const char *);
	static PiMercuryClass *instance();
	~PiMercuryClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	PiMercuryClass(string &);
	static PiMercuryClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace PiMercury_ns

#endif // _PIMERCURYCLASS_H
